package com.hzya.frame.plugin.lets.util;

import cn.hutool.core.lang.Assert;
import com.hzya.frame.plugin.lets.constant.OverallConstant;
import com.hzya.frame.plugin.lets.constant.ProfilesActiveConstant;
import com.hzya.frame.plugin.lets.dao.*;
import com.hzya.frame.plugin.lets.entity.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 查询U8C实体工具类，返回对象
 */
@Component
public class QueryU8CEntityUtil {

    ////////////////////////////////////////////////////////////////////////////////////////公司
    @Autowired
    private IBdCorpDao iBdCorpDao;

    /**
     * 查询全公司
     */
    public List<BdCorpEntity> queryBdCorp() {
        BdCorpEntity entity = new BdCorpEntity();
        entity.setDr(0);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdCorpEntity> query = iBdCorpDao.query(entity);
        return query;
    }

    /**
     * 根据公司编码UNITCode查询公司
     */
    public BdCorpEntity queryBdCorpByUnitCode(String unitCode) {
        BdCorpEntity entity = new BdCorpEntity();
        entity.setDr(0);
        entity.setUnitcode(unitCode);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdCorpEntity> query = iBdCorpDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    /**
     * 根据公司主键pk_corp查询公司
     */
    public BdCorpEntity queryBdCorpByPkCorp(String pkCorp) {
        BdCorpEntity entity = new BdCorpEntity();
        entity.setDr(0);
        entity.setPkCorp(pkCorp);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdCorpEntity> query = iBdCorpDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }
    ////////////////////////////////////////////////////////////////////////////////////////公司

    ////////////////////////////////////////////////////////////////////////////////////////仓库
    @Autowired
    private IBdStordocDao iBdStordocDao;

    /**
     * 根据仓库编码查询仓库
     *
     * @param storCode
     * @return
     */
    public BdStordocEntity queryBdStordocByCode(String storCode) {
        BdStordocEntity entity = new BdStordocEntity();
        entity.setDr(0L);
        entity.setStorcode(storCode);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdStordocEntity> query = iBdStordocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    /**
     * 根据仓库主键查询仓库
     *
     * @param pkStordoc
     * @return
     */
    public BdStordocEntity queryBdStordocByPk(String pkStordoc) {
        BdStordocEntity entity = new BdStordocEntity();
        entity.setDr(0L);
        entity.setPkStordoc(pkStordoc);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdStordocEntity> query = iBdStordocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    /**
     * 根据仓库名称查询仓库
     *
     * @param StorName
     * @return
     */
    public BdStordocEntity queryBdStordocByNamek(String StorName) {
        BdStordocEntity entity = new BdStordocEntity();
        entity.setDr(0L);
        entity.setStorname(StorName);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdStordocEntity> query = iBdStordocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    /**
     * 根据仓库编码+公司编码查询仓库
     *
     * @param storCode
     * @param pkCorp
     * @return
     */
    public BdStordocEntity queryBdStordocByCodeAndPkCorp(String storCode, String pkCorp) {
        BdStordocEntity entity = new BdStordocEntity();
        entity.setDr(0L);
        entity.setStorcode(storCode);
        entity.setPkCorp(pkCorp);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdStordocEntity> query = iBdStordocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }
    ////////////////////////////////////////////////////////////////////////////////////////仓库

    ////////////////////////////////////////////////////////////////////////////////////////存货基本档案
    @Autowired
    private IBdInvbasdocDao iBdInvbasdocDao;

    /**
     * 根据存货编码查询存货基本档案
     */
    public BdInvbasdocEntity queryBdInvbasdocByCode(String invcode) {
        BdInvbasdocEntity entity = new BdInvbasdocEntity();
        entity.setInvcode(invcode);
        entity.setDr(0L);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdInvbasdocEntity> query = iBdInvbasdocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    /**
     * 根据存货基本档案主键查询存货基本档案
     */
    public BdInvbasdocEntity queryBdInvbasdocByPkInvbasdoc(String pkInvbasdoc) {
        BdInvbasdocEntity entity = new BdInvbasdocEntity();
        entity.setPkInvbasdoc(pkInvbasdoc);
        entity.setDr(0L);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdInvbasdocEntity> query = iBdInvbasdocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }
    ////////////////////////////////////////////////////////////////////////////////////////存货基本档案

    ////////////////////////////////////////////////////////////////////////////////////////存货管理档案
    @Autowired
    private IBdInvmandocDao iBdInvmandocDao;

    /**
     * 根据存货基本档案主键+公司主键查询存货管理档案
     */
    public BdInvmandocEntity queryBdInvmandocByPkInvbasdocAndPkCorp(String pkInvbasdoc, String pkCorp) {
        BdInvmandocEntity entity = new BdInvmandocEntity();
        entity.setPkCorp(pkCorp);
        entity.setPkInvbasdoc(pkInvbasdoc);
        entity.setDr(0L);
        entity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdInvmandocEntity> query = iBdInvmandocDao.query(entity);
        if (query.size() >= 1) {
            return query.get(0);
        } else {
            return null;
        }
    }

    ////////////////////////////////////////////////////////////////////////////////////////存货管理档案


    ////////////////////////////////////////////////////////////////////////////////////////存货分类开始
    @Autowired
    private IBdInvclDao iBdInvclDao;

    /**
     * 根据存货，查询对应的存货分类
     *
     * @author liuyang
     */
    public BdInvclEntity queryBdInvbasdocByBdInvcl(BdInvbasdocEntity bdInvbasdocEntity) throws Exception {
        Assert.notNull(bdInvbasdocEntity, "bdInvbasdocEntity不能为空");
        String pkInvcl = bdInvbasdocEntity.getPkInvcl();
        Assert.notNull(pkInvcl, "存货:{}，对应的存货分类主键不能为空!", bdInvbasdocEntity.getInvcode());
        Assert.state(!"".equals(pkInvcl), "存货:{}，对应的存货分类主键不能为空!", bdInvbasdocEntity.getInvcode());

        BdInvclEntity bdInvclEntity = new BdInvclEntity();
        bdInvclEntity.setPkInvcl(pkInvcl);
        bdInvclEntity.setDr(0);
        bdInvclEntity.setDataSourceCode("lets_u8c");
        List<BdInvclEntity> bdInvclEntityList = iBdInvclDao.query(bdInvclEntity);
        if (bdInvclEntityList == null || bdInvclEntityList.size() == 0) {
            Assert.state(false, "根据存货分类主键，无法查询到对应的U8C存货分类档案！主键：{}", pkInvcl);
        }
        return bdInvclEntityList.get(0);
    }
    ////////////////////////////////////////////////////////////////////////////////////////存货分类结束


    ////////////////////////////////////////////////////////////////////////////////////////存货分类-收支项目开始
    @Autowired
    private IBdDefdocDao iBdDefdocDao;

    @Autowired
    private IBdCostsubjDao iBdCostsubjDao;

    /**
     * 根据，存货分类，查询对应的收支项目
     *
     * @author liuyang
     */
    public BdCostsubjEntity queryBdCostsubj(BdInvclEntity bdInvclEntity) {
        Assert.notNull(bdInvclEntity, "bdInvclEntity不能为空!");

        String platformZdyId2 = OverallConstant.getOverAllValue("u8c自定义项档案-存货分类对应收支项目主键");
        BdDefdocEntity bdDefdocEntity = new BdDefdocEntity();
        bdDefdocEntity.setDoccode(bdInvclEntity.getInvclasscode());
        bdDefdocEntity.setPkDefdoclist(platformZdyId2);
        bdDefdocEntity.setDr(0);
        bdDefdocEntity.setDataSourceCode("lets_u8c");
        List<BdDefdocEntity> bdDefdocEntityList = iBdDefdocDao.query(bdDefdocEntity);
        if (bdDefdocEntityList == null || bdDefdocEntityList.size() == 0) {
            Assert.state(false, "在「存货分类对应收支项目」档案中无法匹配到自定义档案！存货分类编码：{} 自定义项档案编码：{}", bdInvclEntity.getInvclasscode(), platformZdyId2);
        } else if (bdDefdocEntityList.size() >= 2) {
            Assert.state(false, "在「存货分类对应收支项目」档案中匹配到{}个自定义档案！存在歧义！ 存货分类编码：{} 自定义项档案编码：{}", bdDefdocEntityList.size(), bdInvclEntity.getInvclasscode(), platformZdyId2);
        }
        BdDefdocEntity bdDefdocEntity1 = bdDefdocEntityList.get(0);
        String memo = bdDefdocEntity1.getMemo();
        Assert.notNull(memo, "在档案：「存货分类对应收支项目」，档案编码：{} 档案名称：{}，对应的备注字段（记录收支项目编码）不能为空！", bdDefdocEntity1.getDoccode(), bdDefdocEntity1.getDocname());
        Assert.state(!"".equals(memo), "在档案：「存货分类对应收支项目」，档案编码：{} 档案名称：{}，对应的备注字段（记录收支项目编码）不能为空！", bdDefdocEntity1.getDoccode(), bdDefdocEntity1.getDocname());

        //查询对应的收知项目档案
        BdCostsubjEntity bdCostsubjEntity = new BdCostsubjEntity();
        bdCostsubjEntity.setDr("0");
        bdCostsubjEntity.setCostcode(memo);
        bdCostsubjEntity.setDataSourceCode("lets_u8c");
        List<BdCostsubjEntity> bdCostsubjEntityList = iBdCostsubjDao.query(bdCostsubjEntity);
        if (bdCostsubjEntityList == null || bdCostsubjEntityList.size() == 0) {
            Assert.state(false, "无法匹配到U8C收支项目 编码:{}", memo);
        }
        return bdCostsubjEntityList.get(0);
    }
    ////////////////////////////////////////////////////////////////////////////////////////存货分类-收支项目结束


    ////////////////////////////////////////////////////////////////////////////////////////公司自定义档案查询

    /**
     * 公司三对一
     * KS	上海棵丝网络科技有限公司
     * YX	杭州言禧电子商务有限公司
     * YD	杭州盈达电子商务有限公司
     * 都传到 YD,杭州盈达电子商务有限公司
     * SELECT * FROM BD_DEFDOC WHERE pk_defdoclist=(SELECT pk_defdoclist FROM BD_DEFDOCLIST WHERE doclistcode='GSDY')-- 0001A11000000004XB42
     *
     * @param corpCode 公司编码
     * @return corpCode 如果时需要转换的会自动转换，如果不需要返回原始公司编码
     */
    public String queryBdDefDocByPkDefDocList(String corpCode) {
        Assert.notNull(corpCode, "公司三对一,入参公司不能为空！！！");

        BdDefdocEntity bdDefdocEntity = new BdDefdocEntity();
        bdDefdocEntity.setPkDefdoclist(OverallConstant.getOverAllValue("u8c自定义项档案-公司对照"));
        bdDefdocEntity.setDr(0);
        bdDefdocEntity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        bdDefdocEntity.setDoccode(corpCode.trim());
        List<BdDefdocEntity> bdDefdocEntityList = iBdDefdocDao.query(bdDefdocEntity);
        if (bdDefdocEntityList != null && bdDefdocEntityList.size() == 1) {
//            Assert.state(false, "根据：自定义档案列表编码：GSDY，主键：[{}]，未查询到自定义档案", OverallConstant.getOverAllValue("u8c自定义项档案-公司对照"));
            BdDefdocEntity bdDefdocEntity1 = bdDefdocEntityList.get(0);
            String memo = bdDefdocEntity1.getMemo();
            if (memo != null && !"".equals(memo)) {
                String[] split = memo.split(",");
                if (split.length > 0) {
                    return split[0];
                }
            }
        } else if (bdDefdocEntityList != null && bdDefdocEntityList.size() >= 2) {
            Assert.state(false, "存在歧义的匹配关系 公司编码：{}存在{}行对照关系！", corpCode);
        }
        return corpCode;
//        List<String> corpCollect = bdDefdocEntityList.stream().map(BdDefdocEntity::getDoccode).collect(Collectors.toList());
//        if (corpCollect.contains(corpCode)) {
//            String memo = bdDefdocEntityList.get(0).getMemo();
//            String[] split = memo.split(",");
//            if (split.length > 0) {
//                corpCode = split[0];
//            }
//        }
//        return corpCode;
    }

    //key为原公司编码，value为现公司编码
    public Map<String, String> queryBdDefDocByPkDefDocAll() {
        Map<String, String> stringStringHashMap = new HashMap<>();

        BdDefdocEntity bdDefdocEntity = new BdDefdocEntity();
        bdDefdocEntity.setPkDefdoclist(OverallConstant.getOverAllValue("u8c自定义项档案-公司对照"));
        bdDefdocEntity.setDr(0);
        bdDefdocEntity.setDataSourceCode(ProfilesActiveConstant.LETS_DATE_SOURCE);
        List<BdDefdocEntity> bdDefdocEntityList = iBdDefdocDao.query(bdDefdocEntity);
        if (bdDefdocEntityList != null && bdDefdocEntityList.size() > 1) {
            for (int i = 0; i < bdDefdocEntityList.size(); i++) {
                BdDefdocEntity bdDefdocEntity1 = bdDefdocEntityList.get(i);
                String doccode = bdDefdocEntity1.getDoccode();
                String memo = bdDefdocEntity1.getMemo();

                if (doccode != null && doccode.length() > 0 && memo != null && memo.length() > 0) {
                    String[] split = memo.split(",");
                    if (split.length > 0) {
                        stringStringHashMap.put(doccode.trim(), split[0]);
                    }
                }
            }
        }
        return stringStringHashMap;
    }
    ////////////////////////////////////////////////////////////////////////////////////////公司自定义档案查询

    @Autowired
    private IBdCubasdocDao iBdCubasdocDao;

    /**
     * 模糊匹配会员id，在客商档案的自定义项1
     * 1889,1888
     * 188
     * 和佳妮确认TOC对应的客商不会存在def1逗号的问题
     *
     * @author liuyang
     */
    public BdCubasdocEntity getFuzzyQueryCustomers(String memberId) {
        //拆分之后收集好
        Map<String, BdCubasdocEntity> bdCubasdocEntityMap = new HashMap<>();

        if (memberId != null && !"".equals(memberId.trim())) {
            BdCubasdocEntity bdCubasdocEntity = new BdCubasdocEntity();
            bdCubasdocEntity.setDataSourceCode("lets_u8c");
            bdCubasdocEntity.setDr(0L);
            bdCubasdocEntity.setDef1(memberId.trim());//模糊查询客商档案
            List<BdCubasdocEntity> bdCubasdocEntityList = iBdCubasdocDao.query(bdCubasdocEntity);
            if (bdCubasdocEntityList != null && bdCubasdocEntityList.size() > 0) {
                for (int i = 0; i < bdCubasdocEntityList.size(); i++) {
                    BdCubasdocEntity bdCubasdocEntity1 = bdCubasdocEntityList.get(i);
                    String def1 = bdCubasdocEntity1.getDef1();
                    if (def1 != null && !"".equals(def1)) {
                        if (def1.contains(",")) {
                            //存在逗号
                            String[] split = def1.split(",");
                            for (int j = 0; j < split.length; j++) {
                                String targetMemberId = split[j];
                                bdCubasdocEntityMap.put(targetMemberId, bdCubasdocEntity1);
                            }
                        } else {
                            //不存在逗号
                            bdCubasdocEntityMap.put(def1, bdCubasdocEntity1);
                        }
                    }
                }
            }
        }

        return bdCubasdocEntityMap.get(memberId);
    }
}
